      * Sample of sending a message with a base64 encoded attachment                                
      * using the Apache Portable Runtime Base64 API.                                               
      *                                      Scott Klement 07/27/2006                               
      *                                                                                             
      * Before compiling:                                                                           
      *   -- Change the "from" and "to" e-mail addresses at                                         
      *       the top of the calc specs, below!                                                     
      *   -- Change the name of the file you want to attach                                         
      *       at the top of the calc specs, below!                                                  
      *                                                                                             
      * To Compile:                                                                                 
      *>   CRTRPGMOD MODULE(QTEMP/ATTDEMO) -                                                        
      *>             SRCFILE(*LIBL/QRPGLESRC) -                                                     
      *>             DBGVIEW(*LIST)                                                                 
      *                                                                                             
      *>   CRTPGM PGM(ATTDEMO) -                                                                    
      *>          MODULE(QTEMP/ATTDEMO) -                                                           
      *>          BNDSRVPGM(QTCP/QTMMSNDM QSYSDIR/QAXIS10HT)                                        
      *                                                                                             
      *                                                                                             
     H BNDDIR('QC2LE') OPTION(*SRCSTMT:*NOSHOWCPY)                                                  
                                                                                                    
     D Text            s             78A   DIM(7) CTDATA PERRCD(1)                                  
                                                                                                    
      /copy ifsio_h                                                                                 
      /copy sendmail_h                                                                              
      /copy apr_b64_h                                                                               
                                                                                                    
     D QCMDEXC         PR                  ExtPgm('QCMDEXC')                                        
     D   cmd                      32702A   const options(*varsize)                                  
     D   len                         15P 5 const                                                    
                                                                                                    
     D tmpnam          PR              *   extproc('_C_IFS_tmpnam')                                 
     D   string                      39A   options(*omit)                                           
                                                                                                    
     D ReportError     PR                                                                           
     D MailDate        PR            31A                                                            
                                                                                                    
     D CRLF            c                   x'0d25'                                                  
                                                                                                    
     D fromName        s            100A   varying                                                  
     D fromAddr        s            300A   varying                                                  
     D toName          s            100A   varying                                                  
     D toAddr          s            300A   varying                                                  
     D subject         s             80A   varying                                                  
                                                                                                    
     D attName         s             50A   varying                                                  
     D attFile         s            500a   varying                                                  
     D mimeType        s            100a   varying                                                  
                                                                                                    
     D filename        s             50A   varying                                                  
     D att             s             10I 0                                                          
     D fd              s             10I 0                                                          
     D header          s           2000A   varying                                                  
     D body            s            500A   varying                                                  
     D cmd             s            500A   varying                                                  
     D boundary        s             78A   varying                                                  
     D x               s             10I 0                                                          
     D data            s             54A                                                            
     D encData         s             74A                                                            
     D encLen          s             10i 0                                                          
     D len             s             10i 0                                                          
                                                                                                    
     D recip           ds                  likeds(ADDTO0100)                                        
     D                                     dim(1)                                                   
     D NullError       ds                                                                           
     D   BytesProv                   10I 0 inz(0)                                                   
     D   BytesAvail                  10I 0 inz(0)                                                   
     D wait            s              1A                                                            
                                                                                                    
      /free                                                                                         
          fromName = 'Scott Klement';                                                               
          fromAddr = 'sklement@iseriesnetwork.com';                                                 
          toName   = 'Faithful Reader';                                                             
          toAddr   = 'freader@example.com';                                                         
          subject  = 'Testing sending a PDF file';                                                  
                                                                                                    
          //                                                                                        
          //  attFile = name of IFS file to attach                                                  
          //  attName = filename to show in e-mail message                                          
          // mimeType = data type of attachment. (Tells e-mail                                      
          //            software what type of data this is --                                       
          //            and is often used to determine how to                                       
          //            open the attachment.)                                                       
          //                                                                                        
                                                                                                    
          attFile  = '/tmp/Employment_app.pdf';                                                     
          attName  = 'Employment Application.pdf';                                                  
          mimeType = 'application/pdf';                                                             
                                                                                                    
          if (%scan('klement': fromAddr)>0                                                          
              or %scan('example': toAddr)>0);                                                       
               dsply ('PLEASE FIX E-MAIL ADDRESSES!');                                              
               dsply ('THEN RUN THIS PROGRAM AGAIN.') ' ' wait;                                     
               return;                                                                              
          endif;                                                                                    
                                                                                                    
                                                                                                    
          // ------------------------------------------                                             
          // create a temporary file in the IFS.                                                    
          // mark that file as ccsid 819 (ISO 8859-1 ASCII)                                         
          // and ask IBM i to translate EBCDIC -> ASCII                                             
          // ------------------------------------------                                             
                                                                                                    
          filename = %str(tmpnam(*omit));                                                           
          unlink(filename);                                                                         
                                                                                                    
          fd = open( filename                                                                       
                   : O_CREAT+O_EXCL+O_WRONLY+O_CCSID                                                
                     +O_TEXTDATA+O_TEXT_CREAT                                                       
                   : M_RDWR                                                                         
                   : 819                                                                            
                   : 0 );                                                                           
          if (fd = -1);                                                                             
             ReportError();                                                                         
          endif;                                                                                    
                                                                                                    
          // ------------------------------------------                                             
          //  build an e-mail header in a variable                                                  
          // ------------------------------------------                                             
          Boundary = '--=_ScottsNiftyBoundary';                                                     
                                                                                                    
          header =                                                                                  
           'From: ' + fromName + ' <' + fromAddr + '>' + CRLF                                       
          +'To: '   + toName   + ' <' + toAddr   + '>' + CRLF                                       
          +'Date: ' + maildate() + CRLF                                                             
          +'Subject: ' + subject + CRLF                                                             
          +'MIME-Version: 1.0' + CRLF                                                               
          +'Content-Type: multipart/mixed;'                                                         
          +   ' boundary="' + Boundary + '"' + CRLF                                                 
          + CRLF                                                                                    
          + 'Your mail reader doesn''t support MIME!' + CRLF                                        
          + CRLF;                                                                                   
                                                                                                    
          callp write(fd: %addr(header)+2: %len(header));                                           
                                                                                                    
          // ------------------------------------------                                             
          //  Insert the headers for the text part                                                  
          // ------------------------------------------                                             
                                                                                                    
          body =                                                                                    
           '--' + boundary + CRLF                                                                   
          +'Content-type: text/plain' + CRLF                                                        
          + CRLF;                                                                                   
          callp write(fd: %addr(body)+2: %len(body));                                               
                                                                                                    
          // ------------------------------------------                                             
          //  Copy the text part from the compile-time                                              
          //  array to the IFS stream file                                                          
          // ------------------------------------------                                             
                                                                                                    
          for x = 1 to %elem(text);                                                                 
             body = %trimr(text(x)) + CRLF;                                                         
             callp write(fd: %addr(body)+2: %len(body));                                            
          endfor;                                                                                   
                                                                                                    
          // ------------------------------------------                                             
          //  Insert the headers for the PDF file                                                   
          // ------------------------------------------                                             
                                                                                                    
          body =                                                                                    
           '--' + boundary + CRLF                                                                   
          +'Content-Type: ' + mimeType + '; '                                                       
          +    'name="' + attname + '"' + CRLF                                                      
          +'Content-Transfer-Encoding: base64' + CRLF                                               
          +'Content-Disposition: attachment; '                                                      
          +    'filename="' + attname + '"' + CRLF                                                  
          + CRLF;                                                                                   
          callp write(fd: %addr(body)+2: %len(body));                                               
                                                                                                    
                                                                                                    
          // ------------------------------------------                                             
          //  Read the attachment file, and base64                                                  
          //  encode it.  Write the results to the                                                  
          //  e-mail message.                                                                       
          // ------------------------------------------                                             
                                                                                                    
          att = open( attFile: O_RDONLY );                                                          
          if (att = -1);                                                                            
             ReportError();                                                                         
          endif;                                                                                    
                                                                                                    
          dow '1';                                                                                  
             len = read(att: %addr(data): %size(data));                                             
             if (len < 1);                                                                          
                leave;                                                                              
             endif;                                                                                 
                                                                                                    
             enclen = apr_base64_encode_binary( encdata                                             
                                              : data                                                
                                              : len ) - 1;                                          
             %subst(encdata:enclen+1) = CRLF;                                                       
             callp write(fd: %addr(encdata): enclen+2);                                             
          enddo;                                                                                    
                                                                                                    
          callp close(att);                                                                         
                                                                                                    
          // ------------------------------------------                                             
          //  Finish the message & close the file                                                   
          // ------------------------------------------                                             
          body = CRLF + '--' + boundary + '--' + CRLF;                                              
          callp write(fd: %addr(body)+2: %len(body));                                               
          callp close(fd);                                                                          
                                                                                                    
          // ------------------------------------------                                             
          //  Use the QtmmSendMail() API to send the                                                
          //  IFS file via SMTP                                                                     
          // ------------------------------------------                                             
                                                                                                    
          recip(1).NextOffset = %size(ADDTO0100);                                                   
          recip(1).AddrFormat = 'ADDR0100';                                                         
          recip(1).DistType   = ADDR_NORMAL;                                                        
          recip(1).Reserved   = 0;                                                                  
          recip(1).SmtpAddr   = toAddr;                                                             
          recip(1).AddrLen    = %len(toAddr);                                                       
                                                                                                    
          QtmmSendMail( FileName                                                                    
                      : %len(FileName)                                                              
                      : fromAddr                                                                    
                      : %len(fromAddr)                                                              
                      : recip                                                                       
                      : %elem(recip)                                                                
                      : NullError );                                                                
                                                                                                    
          *inlr = *on;                                                                              
      /end-free                                                                                     
                                                                                                    
                                                                                                    
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
      * ReportError():  Send an escape message explaining any errors                                
      *                 that occurred.                                                              
      *                                                                                             
      *  This function requires binding directory QC2LE in order                                    
      *  to access the __errno() function.                                                          
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                            
     P ReportError     B                                                                            
     D ReportError     PI                                                                           
                                                                                                    
     D get_errno       PR              *   ExtProc('__errno')                                       
     D ptrToErrno      s               *                                                            
     D errno           s             10I 0 based(ptrToErrno)                                        
                                                                                                    
     D QMHSNDPM        PR                  ExtPgm('QMHSNDPM')                                       
     D   MessageID                    7A   Const                                                    
     D   QualMsgF                    20A   Const                                                    
     D   MsgData                      1A   Const                                                    
     D   MsgDtaLen                   10I 0 Const                                                    
     D   MsgType                     10A   Const                                                    
     D   CallStkEnt                  10A   Const                                                    
     D   CallStkCnt                  10I 0 Const                                                    
     D   MessageKey                   4A                                                            
     D   ErrorCode                 8192A   options(*varsize)                                        
                                                                                                    
     D ErrorCode       DS                  qualified                                                
     D  BytesProv              1      4I 0 inz(0)                                                   
     D  BytesAvail             5      8I 0 inz(0)                                                   
                                                                                                    
     D MsgKey          S              4A                                                            
     D MsgID           s              7A                                                            
                                                                                                    
      /free                                                                                         
                                                                                                    
         ptrToErrno = get_errno();                                                                  
         MsgID = 'CPE' + %char(errno);                                                              
                                                                                                    
         QMHSNDPM( MsgID                                                                            
                 : 'QCPFMSG   *LIBL'                                                                
                 : ' '                                                                              
                 : 0                                                                                
                 : '*ESCAPE'                                                                        
                 : '*PGMBDY'                                                                        
                 : 1                                                                                
                 : MsgKey                                                                           
                 : ErrorCode         );                                                             
                                                                                                    
      /end-free                                                                                     
     P                 E                                                                            
                                                                                                    
                                                                                                    
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                                
      * maildate(): Get current date/time in format required for SMTP                               
      *                                                                                             
      *     For example:  'Mon, 15 Aug 2006 14:30:06 -0500'                                         
      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                                
     P maildate        B                                                                            
     D maildate        PI            31A                                                            
                                                                                                    
     D CEEUTCO         PR                  opdesc                                                   
     D   Hours                       10I 0                                                          
     D   Minutes                     10I 0                                                          
     D   Seconds                      8F                                                            
     D   fc                          12A   options(*omit)                                           
                                                                                                    
     D SUNDAY          C                   d'1899-12-31'                                            
                                                                                                    
     D junk1           s              8F                                                            
     D hours           s             10I 0                                                          
     D mins            s             10I 0                                                          
     D tz_hours        s              2P 0                                                          
     D tz_mins         s              2P 0                                                          
     D tz              s              5A   varying                                                  
                                                                                                    
     D CurTS           s               Z                                                            
     D CurTime         s              8a   varying                                                  
     D CurDay          s              2p 0                                                          
     D CurYear         s              4p 0                                                          
     D CurMM           s              2p 0                                                          
     D CurMonth        s              3a   varying                                                  
     D TempDOW         s             10i 0                                                          
     D CurDOW          s              3a   varying                                                  
                                                                                                    
     D DateString      s             31a                                                            
                                                                                                    
      /free                                                                                         
                                                                                                    
         //                                                                                         
         //  Calculate the Timezone in format '+0000', for example                                  
         //    CST should show up as '-0600'                                                        
         //                                                                                         
                                                                                                    
         CEEUTCO(hours: mins: junk1: *omit);                                                        
         tz_hours = %abs(hours);                                                                    
         tz_mins = mins;                                                                            
                                                                                                    
         if (hours < 0);                                                                            
            tz = '-';                                                                               
         else;                                                                                      
            tz = '+';                                                                               
         endif;                                                                                     
                                                                                                    
         tz += %editc(tz_hours:'X') + %editc(tz_mins:'X');                                          
                                                                                                    
         //                                                                                         
         //  Get the current time and convert it to the format                                      
         //    specified for e-mail in RFC 2822                                                     
         //                                                                                         
                                                                                                    
         CurTS = %timestamp();                                                                      
                                                                                                    
         CurTime = %char(%time(CurTS): *HMS:);                                                      
                                                                                                    
         CurDay  = %subdt(CurTS: *DAYS);                                                            
         CurYear = %subdt(CurTS: *YEARS);                                                           
         CurMM   = %subdt(CurTS: *MONTHS);                                                          
                                                                                                    
         select;                                                                                    
         when CurMM = 1;                                                                            
           CurMonth = 'Jan';                                                                        
         when CurMM = 2;                                                                            
           CurMonth = 'Feb';                                                                        
         when CurMM = 3;                                                                            
           CurMonth = 'Mar';                                                                        
         when CurMM = 4;                                                                            
           CurMonth = 'Apr';                                                                        
         when CurMM = 5;                                                                            
           CurMonth = 'May';                                                                        
         when CurMM = 6;                                                                            
           CurMonth = 'Jun';                                                                        
         when CurMM = 7;                                                                            
           CurMonth = 'Jul';                                                                        
         when CurMM = 8;                                                                            
           CurMonth = 'Aug';                                                                        
         when CurMM = 9;                                                                            
           CurMonth = 'Sep';                                                                        
         when CurMM = 10;                                                                           
           CurMonth = 'Oct';                                                                        
         when CurMM = 11;                                                                           
           CurMonth = 'Nov';                                                                        
         when CurMM = 12;                                                                           
           CurMonth = 'Dec';                                                                        
         endsl;                                                                                     
                                                                                                    
         TempDOW = %diff( %date(CurTS) : SUNDAY : *DAYS );                                          
         TempDOW = %rem( TempDOW : 7 );                                                             
                                                                                                    
         Select;                                                                                    
         when TempDOW = 0;                                                                          
           CurDOW = 'Sun';                                                                          
         when TempDOW = 1;                                                                          
           CurDOW = 'Mon';                                                                          
         when TempDOW = 2;                                                                          
           CurDOW = 'Tue';                                                                          
         when TempDOW = 3;                                                                          
           CurDOW = 'Wed';                                                                          
         when TempDOW = 4;                                                                          
           CurDOW = 'Thu';                                                                          
         when TempDOW = 5;                                                                          
           CurDOW = 'Fri';                                                                          
         when TempDOW = 6;                                                                          
           CurDOW = 'Sat';                                                                          
         endsl;                                                                                     
                                                                                                    
         DateString = CurDOW + ', '                                                                 
                    + %editc( CurDay: 'X' ) + ' '                                                   
                    + CurMonth + ' '                                                                
                    + %editc( CurYear: 'X' ) + ' '                                                  
                    + CurTime + ' '                                                                 
                    + tz;                                                                           
                                                                                                    
         return DateString;                                                                         
                                                                                                    
      /end-free                                                                                     
     P                 E                                                                            
** ------------------ Text Part -----------------------                                             
Hi there,                                                                                           
                                                                                                    
The purpose of this message is to send you the attached                                             
file. You can open it in Adobe Reader or any other                                                  
program that understands PDF files.                                                                 
                                                                                                    
Good luck!                                                                                          
